package eap.parfile;

import java.util.*;

/*****************************************************************************
*
*****************************************************************************/
public class Parameter {

String name;
String type;
String mode;
String value;
String min;
String max;
String prompt;


/*****************************************************************************
*
*****************************************************************************/
public Parameter(String line) throws ParameterException {

    int from=0;
    boolean quote=false;
    int index=0;

    for(int to=0; to<line.length(); ++to) {
    
        char c = line.charAt(to);
        if(c == '"') quote = ! quote;
        else if(! quote && c == ',') {
            /******************
            * field separator *
            ******************/
            String field = line.substring(from, to).trim();
            from=to+1;
            
            if(     index==0) name=field;
            else if(index==1) type=field;
            else if(index==2) mode=field;
            else if(index==3) value=field;
            else if(index==4) min=field;
            else if(index==5) max=field;
            else {
                throw new ParameterException("Too many fields in"+line);
            }
            
            ++index;

           // System.out.println("    "+index+" "+field);
        }
    }
    
    prompt = line.substring(from).trim();

   // System.out.println("    "+prompt);




} // end of constructor

/*****************************************************************************
*
*****************************************************************************/
private static String unquote(String string) {

    if(string.startsWith("\"") && string.endsWith("\"") ) {
        return string.substring(1, string.length()-1);
    } else {
        return string;
    }
    
} // end of unquote method

/***************************************************************************
*
***************************************************************************/
public String getName() { return name; }

/***************************************************************************
*
***************************************************************************/
public String getType() { return type; }

/***************************************************************************
*
***************************************************************************/
public String getMode() { return mode; }

/***************************************************************************
*
***************************************************************************/
public String getValue() { return unquote(value); }

/***************************************************************************
*
***************************************************************************/
public String getPrompt() { return unquote(prompt); }
/***************************************************************************
*
***************************************************************************/
public String toString() {

    return name+","+type+","+mode+","+value+","+min+","+max+","+prompt;

} // end of toString method

} // end of Parameter class
