package eap.parfile;

import java.io.*;
import java.util.*;

/*****************************************************************************
*
*****************************************************************************/
public class Parfile {

Map parameters;

/*****************************************************************************
* Make a new empty parameter file
*****************************************************************************/
public Parfile() {
    parameters = new HashMap();
}

/*****************************************************************************
*
*****************************************************************************/
public Parfile(BufferedReader reader) throws IOException, ParameterException {

    this();

    String line;
    while((line = reader.readLine()) != null) {

        line = line.trim();
        if(line.length()==0) continue;
        if(line.startsWith("#")) continue;

       // System.out.println(line);
        addParameter(new Parameter(line));

    } // end of loop over lines


} // end of constructor

/*****************************************************************************
*
*****************************************************************************/
public void addParameter(Parameter param) { 

    parameters.put(param.getName(),param); 
    //System.out.println("added "+param);

} // end of addparameter method

/*****************************************************************************
*
*****************************************************************************/
public Parameter get(String name) throws NoSuchParameterException {

    Parameter param = (Parameter)parameters.get(name);
    if(param==null) throw new NoSuchParameterException();
    
    return param;

}

/*****************************************************************************
* return a set containing the names of all the parameters
*****************************************************************************/
public Set getParameters() { return new HashSet(parameters.keySet()); }

/*****************************************************************************
*
*****************************************************************************/
public String getString(String name) throws ParameterException {

    String value = get(name).getValue();
    return value;
}



/*****************************************************************************
*
*****************************************************************************/
public static void main(String[] args) throws Exception {

    BufferedReader reader = new BufferedReader(new FileReader("../imagetrans.par"));

    Parfile parfile = new Parfile(reader);
    



} // end of main method



} // end of Parfile class
